apiVersion: v1
kind: ServiceAccount
metadata:
  name: dind-cleaner
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: dind-cleaner
rules:
- apiGroups: ["apps"]
  resources: ["statefulsets"]
  verbs: ["get", "list"]
- apiGroups: [""]
  resources: ["pods", "pods/log"]
  verbs: ["get", "list"]
- apiGroups: [""]
  resources: ["pods/exec"]
  verbs: ["create"]
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: dind-cleaner
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: dind-cleaner
subjects:
- kind: ServiceAccount
  name: dind-cleaner
---
apiVersion: batch/v1
kind: CronJob
metadata:
  name: dind-cleaner
spec:
  schedule: "{{ k8s_dind_cleaner_cron }}"
  successfulJobsHistoryLimit: 1
  jobTemplate:
    spec:
      template:
        spec:
          serviceAccountName: dind-cleaner
          containers:
          - name: kubectl
            image: bitnami/kubectl
            command:
              - "bin/bash"
              - "-c"
              - |
                REPLICAS=$(kubectl get sts dind -n {{ k8s_dind_namespace }} -o jsonpath='{.status.replicas}')
                for STS_ID in $(seq 0 $(($REPLICAS-1))); do
                    echo "Cleaning up dind-$STS_ID"
                    COMMAND="docker -H tcp://0.0.0.0:2375 image prune -f {{ image_filter_args | default('') | trim }}; df -H | grep /var/lib/docker"
                    kubectl exec dind-$STS_ID -n {{ k8s_dind_namespace }} -- sh -c "$COMMAND"
                done
          restartPolicy: OnFailure
